% 1. megolds
% -----------

:- use_module(library(lists)).


% anbn(N, L): Az L lista N db a-bl
% s azt kvet N db b-bl ll.
anbn(N, L) :-
        an(N, a, AN),
        an(N, b, BN),
        append(AN, BN, L).

% an(N, A, L): L az A elemet N-szer
% tartalmaz lista
an(0, _A, L) :- !, L = [].
an(N, A, [A|L]) :-
        N > 0,
        N1 is N-1,
        an(N1, A, L).


% 2. megolds
% -----------

% anbn2(N, L): Az L lista N db a-bl
% s azt kvet N db b-bl ll.
anbn2(N, L) :-
        an(N, b, [], BN),
        an(N, a, BN, L).


% an(N, A, L0, L): L0-L az A 
% elemet N-szer tartalmaz lista
an(0, _A, L0, L) :- !, L = L0.
an(N, A, L0, [A|L]) :-
        N > 0,
        N1 is N-1,
        an(N1, A, L0, L).


% 3. megolds
% -----------

% anbn3(N, L): Az L lista N db a-bl
% s azt kvet N db b-bl ll.
anbn3(N, L) :-
        anbn(N, [], L).

% anbn(N, L0, L): Az L-L0 lista N db a-bl
% s azt kvet N db b-bl ll.
anbn(0, L0, L) :- !, L = L0.
anbn(N, L0, [a|L]) :-
        N > 0,
        N1 is N-1,
        anbn(N1, [b|L0], L).


% Ugyanez rszletesebben kifejtve (nem jobbrekurzv!)
% anbn(0, L0, L) :- !, L = L0.
% anbn(N, L0, L) :-
% 	  N > 0, N1 is N-1,
% 	  L1 = [b|L0],      % 1. lps: L0 el b => L1
% 	  anbn(N1, L1, L2), % 2. lps: L1 el a^N1 b^N1 => L2
% 	  L = [a|L2].       % 3. lps: L2 el a => L
