% leelemezhet egy decimlisszmjegy-sorozat
szm --> szmjegy, szmmaradk.

% leelemezhet szmjegyek egy esetleg res listja.
szmmaradk -->
    szmjegy, !, szmmaradk.
szmmaradk --> [].

% leelemezhet egy decimlis szmjegy.
szmjegy --> [K], {decimlis_jegy_kdja(K)}.

% K egy szmjegy kdja.
decimlis_jegy_kdja(K):- 
	K >= 0'0, K =< 0'9.

% leelemezhet egy Sz rtk decimlisszmjegy-sorozat
szm(X) --> szmjegy(X0), szmmaradk(X0, X).

% leelemezhet szmjegyek egy esetleg res listja, amelynek
% az eddig leelemzett Sz0-val egytt vett rtke Sz.
szmmaradk(Sz0, Sz) -->
    szmjegy(J), !, {Sz1 is Sz0*10+J}, szmmaradk(Sz1, Sz).
szmmaradk(Sz0, Sz0) --> [].

% leelemezhet egy J rtk szmjegy.
szmjegy(J) --> [K], {decimlis_jegy_kdja(K), J is K-0'0}.

% L szmlista sszege S.
sum(L, S) :- sum(L, 0, S).

% sum(L, S0, S): L szmlista sszege S-S0.
sum([]) --> [].
sum([X|L]) --> plus(X), sum(L).

% X+S0 = S.
plus(X, S0, S) :- S is S0+X.


% anbn(N, L): Az L lista N db a-bl s azt kvet N db b-bl ll.
anbn(N, L) :- anbn(N, L, []).

% anbn(N, L0, L): L0-L N db a-bl s azt kvet N db b-bl ll.
anbn(0) --> !.
anbn(N) --> {N > 0, N1 is N-1}, [a], anbn(N1), [b].

% anbn(N, L0, L): L0-L N db a-bl s azt kvet N db b-bl ll.
% Ugyanaz mint anbn/3, csak DCG nlkl.
anbn1(0, L0, L) :- !, L0 = L.
anbn1(N, L0, L) :- N > 0, N1 is N-1, L0=[a|L1], anbn1(N1, L1, L2), L2=[b|L].

% kif(Z, L0, L): L0 elejn egy Z rtk aritmetikai kifejezs ll, marad L.
kif(Z) --> tag(X), "+", kif(Y), {Z is X + Y}.
kif(Z) --> tag(X), "-", kif(Y), {Z is X - Y}.
kif(X) --> tag(X).

% tag(Z, L0, L): L0-bl leelemezhet egy Z rtk tag, marad L.
tag(Z) --> szm(X), "*", tag(Y), {Z is X * Y}.
tag(Z) --> szm(X), "/", tag(Y), {Z is X / Y}.
tag(X) --> szm(X).

% kif2(Z, L0, L): L0 elejn egy Z rtk aritmetikai kifejezs ll, marad L.
kif2(Z) --> tag2(X), kifmaradk(X, Z).

% Leelemezhet nulla vagy tbb additv mvelet s azt kvet tag, amelyeknek
% egy eddig leelemzett X szmrtkkel egytt vett rtke Z.
kifmaradk(X, Z) --> "+", tag2(Y), {W is X + Y}, kifmaradk(W, Z).
kifmaradk(X, Z) --> "-", tag2(Y), {W is X - Y}, kifmaradk(W, Z).
kifmaradk(X, X) --> [].

% Leelemezhet egy Z rtk tag.
tag2(Z) --> szm(X), tagmaradk(X, Z).

% Leelemezhet nulla vagy tbb multiplikatv mvelet s azt kvet szm, 
% amelyeknek egy eddig leelemzett X szmrtkkel egytt vett rtke Z.
tagmaradk(X, Z) --> "*", szm(Y), {W is X * Y}, tagmaradk(W, Z).
tagmaradk(X, Z) --> "/", szm(Y), {W is X / Y}, tagmaradk(W, Z).
tagmaradk(X, X) --> [].


