% Egy listban fennsknak neveznk:
% -  egy csupa azonos elembl ll, legalbb ktelem, folytonos rszlistt;
% -  amely az ilyenek kztt maximlis (egyik irnyba sem kiterjeszthet).
% A feladat: felsorolandk egy lista fennskjai s kezdpozcijuk.

:- nondet(fennsk/3).
:- nondet(fennsk/4).

% fennsk(L, F, H)}: Az L listban az F (1-tl szmozott) pozcin egy H
% hossz fennsk van.
fennsk(L, F, H) :-
        fennsk(L, 1, F, H).

% A P0-tl szmozott L0 listban az F pozcin 
% egy H hossz fennsk van.
fennsk(L0, P0, F, H) :-
        % az els fennsk jellemzi F0 s H0, 
        % a fennsk utni maradklista L1:
        els_fennsk(L0, P0, F0, H0, L1), 
        (   F = F0, H = H0
        ;   P1 is F0+H0,   % L1 kezdpozcija, P1, nem ms mint
                           % az elz megolds kezdpozcija+hossza
            fennsk(L1, P1, F, H)
        ).

% els_fennsk(+L0, +P0, -F, -H, -L): A P0-tl szmozott L0 listban az 
% els fennsk az F. pozcin van s hossza H, a fennsk utn fennmarad
% rsz pedig az L lista.
els_fennsk([E,E|L1], P0, F, H, L) :-
        !, F = P0, azonosak(L1, E, 2, H, L).
els_fennsk([_|L1], P0, F, H, L) :-
        P1 is P0+1,
        els_fennsk(L1, P1, F, H, L).

% azonosak(+L0, +E, +H0, -H, -L): Az L0 lista elejrl a maximlis szm
% E-vel azonos elemet lehagyva marad L, a lehagyott elemek szma H-H0.
azonosak([X|L0], E, H0, H, L) :-
        E = X, !,
        H1 is H0+1,
        azonosak(L0, E, H1, H, L).
azonosak(L, _, H, H, L).
